------------------------------------------------------
-- Written by Saur of Emerald Dream, EU.
-- A lot of code was borrowed from Fizzwidget Disenchant Predictor by Gazmik Fizzwidget
------------------------------------------------------

local FHDKP_RecipeValue = {
	[2] = 5;	-- Uncommon
	[3] = 10;	-- Rare
	[4] = 15;	-- Epic
}

local FHDKP_ItemValue = {
	[3] = 0.25;	-- Rare
	[4] = 1;	-- Epic
	[5] = 2;	-- Legendary
}

local FHDKP_SlotValue = {
	["INVTYPE_2HWEAPON"] = 2;

	["INVTYPE_WEAPON"] = 1.5;
	["INVTYPE_WEAPONMAINHAND"] = 1.5;
	["INVTYPE_WEAPONOFFHAND"] = 1.5;
	["INVTYPE_RANGED"] = 1.5;
	["INVTYPE_THROWN"] = 1.5;
	["INVTYPE_SHIELD"] = 1.5;
	["INVTYPE_HOLDABLE"] = 1.5;	-- Held In Off-hand

	["INVTYPE_HEAD"] = 1.25;
	["INVTYPE_CHEST"] = 1.25;
	["INVTYPE_ROBE"] = 1.25;	-- Chest

	["INVTYPE_SHOULDER"] = 1.15;
	["INVTYPE_LEGS"] = 1.15;
	["INVTYPE_FEET"] = 1.15;

	["INVTYPE_HAND"] = 1;
	["INVTYPE_WAIST"] = 1;
	["INVTYPE_WRIST"] = 1;
	["INVTYPE_CLOAK"] = 1;

	["INVTYPE_FINGER"] = 1;
	["INVTYPE_NECK"] = 1;
	["INVTYPE_TRINKET"] = 1;
	["INVTYPE_RANGEDRIGHT"] = 1;	-- Wand
	["INVTYPE_RELIC"] = 1;		-- Libram, Idol, Totem

--	["INVTYPE_AMMO"] = nil;
--	["INVTYPE_BAG"] = nil;
--	["INVTYPE_BODY"] = nil;		-- Shirt
--	["INVTYPE_TABARD"] = nil;
}

local FHDKP_ItemID2Value = {
	-- Tier 4 tokens
	[29753]	= 62.5;		-- Chestguard of the Fallen Hero (Hunter, Mage, Warlock)
	[29754]	= 62.5;		-- Chestguard of the Fallen Champion (Paladin, Rogue, Shaman)
	[29755]	= 62.5;		-- Chestguard of the Fallen Defender (Warrior, Priest, Druid)
	[29756]	= 50;		-- Gloves of the Fallen Hero (Hunter, Mage, Warlock)
	[29757]	= 50;		-- Gloves of the Fallen Champion (Paladin, Rogue, Shaman)
	[29758]	= 50;		-- Gloves of the Fallen Defender (Warrior, Priest, Druid)
	[29759]	= 62.5;		-- Helm of the Fallen Hero (Hunter, Mage, Warlock)
	[29760]	= 62.5;		-- Helm of the Fallen Champion (Paladin, Rogue, Shaman)
	[29761]	= 62.5;		-- Helm of the Fallen Defender (Warrior, Priest, Druid)
	[29762]	= 57.5;		-- Pauldrons of the Fallen Hero (Hunter, Mage, Warlock)
	[29763]	= 57.5;		-- Pauldrons of the Fallen Champion (Paladin, Rogue, Shaman)
	[29764]	= 57.5;		-- Pauldrons of the Fallen Defender (Warrior, Priest, Druid)
	[29765]	= 57.5;		-- Leggings of the Fallen Hero (Hunter, Mage, Warlock)
	[29766]	= 57.5;		-- Leggings of the Fallen Champion (Paladin, Rogue, Shaman)
	[29767]	= 57.5;		-- Leggings of the Fallen Defender (Warrior, Priest, Druid)

	-- Tier 5 tokens
--	[     ]	= 78.75;	-- Chestguard of the Vanquished Champion (Paladin, Rogue, Shaman)
--	[     ]	= 78.75;	-- Chestguard of the Vanquished Defender (Warrior, Priest, Druid)
--	[     ]	= 78.75;	-- Chestguard of the Vanquished Hero (Hunter, Mage, Warlock)
	[30239]	= 63;		-- Gloves of the Vanquished Champion (Paladin, Rogue, Shaman)
	[30240]	= 63;		-- Gloves of the Vanquished Defender (Warrior, Priest, Druid)
	[30241]	= 63;		-- Gloves of the Vanquished Hero (Hunter, Mage, Warlock)
	[30242]	= 78.75;	-- Helm of the Vanquished Champion (Paladin, Rogue, Shaman)
	[30243]	= 78.75;	-- Helm of the Vanquished Defender (Warrior, Priest, Druid)
	[30244]	= 78.75;	-- Helm of the Vanquished Hero (Hunter, Mage, Warlock)
	[30245]	= 72.45;	-- Leggings of the Vanquished Champion (Paladin, Rogue, Shaman)
	[30246]	= 72.45;	-- Leggings of the Vanquished Defender (Warrior, Priest, Druid)
	[30247]	= 72.45;	-- Leggings of the Vanquished Hero (Hunter, Mage, Warlock)
	[30248]	= 72.45;	-- Pauldrons of the Vanquished Champion (Paladin, Rogue, Shaman)
	[30249]	= 72.45;	-- Pauldrons of the Vanquished Defender (Warrior, Priest, Druid)
	[30250]	= 72.45;	-- Pauldrons of the Vanquished Hero (Hunter, Mage, Warlock)
}

local FHDKP_FONT_COLOR = { r=1, g=0.25, b=0.25 };

local FHDKP_TooltipHooks = {};

function FHDKP_GameTooltip_OnHide()
	local tooltipName = this:GetName();
	FHDKP_SetTooltipHooks(tooltipName);
end

function FHDKP_GameTooltip_SetDefaultAnchor(tooltip, parent)
	local tooltipName = tooltip:GetName();
	FHDKP_SetTooltipHooks(tooltipName);
end

function FHDKP_SetTooltipHooks(tooltipName)
	if not tooltipName or tooltipName == "" then 
		return; 
	end
	
	local tooltip = getglobal(tooltipName);
	if tooltip and tooltip:HasScript("OnTooltipSetItem") and not FHDKP_TooltipHooks[tooltipName] then
		FHDKP_TooltipHooks[tooltipName] = {};
		FHDKP_TooltipHooks[tooltipName].OnTooltipSetItem = tooltip:GetScript("OnTooltipSetItem");
		tooltip:SetScript("OnTooltipSetItem", FHDKP_OnTooltipSetItem);
	end
end

function FHDKP_OnTooltipSetItem()
	local tooltipName = this:GetName();
	local tooltip = getglobal(tooltipName);

	if FHDKP_TooltipHooks[tooltipName] and FHDKP_TooltipHooks[tooltipName].OnTooltipSetItem then
		FHDKP_TooltipHooks[tooltipName].OnTooltipSetItem(tooltip);
	end

	local name, link = this:GetItem();

	if link then
		-- workaround for OnTooltipSetItem being called twice for recipes
		local _, _, _, _, _, itemType, _, _, _, _ = GetItemInfo(link);
		if itemType == "Recipe" and this.fhdkpLastLink ~= link then
			for i = 1, this:NumLines() do
				local line = getglobal(this:GetName() .. "TextLeft" .. i);
				local text = line:GetText();
				if text and string.sub(text, 1, 1) == "\n" then
					this.fhdkpLastLink = link;
					return;
				end
			end
		end
		this.fhdkpLastLink = nil;

		local fhdkpValue, equipLoc = FHDKP_Value(link);
		if fhdkpValue then
			this:AddLine("FH DKP value: " .. fhdkpValue, FHDKP_FONT_COLOR.r, FHDKP_FONT_COLOR.g, FHDKP_FONT_COLOR.b);
		end
	end

	return false;
end

function FHDKP_OnLoad()
	hooksecurefunc("GameTooltip_OnHide", FHDKP_GameTooltip_OnHide);
	hooksecurefunc("GameTooltip_SetDefaultAnchor", FHDKP_GameTooltip_SetDefaultAnchor);
	FHDKP_SetTooltipHooks("GameTooltip");
	FHDKP_SetTooltipHooks("ItemRefTooltip");
	FHDKP_SetTooltipHooks("ShoppingTooltip1");
	FHDKP_SetTooltipHooks("ShoppingTooltip2");

	local version = GetAddOnMetadata("FHDKP", "Version");
	DEFAULT_CHAT_FRAME:AddMessage("FHDKP " .. version .. " initialized!", FHDKP_FONT_COLOR.r, FHDKP_FONT_COLOR.g, FHDKP_FONT_COLOR.b);
end

function FHDKP_Value(itemLink)
	local _, _, itemID = string.find(itemLink, "item:(%d+)");
	itemID = tonumber(itemID);
	if itemID == nil then 
		return nil; 
	end

	if FHDKP_ItemID2Value[itemID] then
		return FHDKP_ItemID2Value[itemID];
	end

	local name, link, quality, itemLevel, minLevel, type, subType, stackCount, equipLoc, texture = GetItemInfo(itemID);	
	
	if type == "Recipe" then
		return FHDKP_RecipeValue[quality];
	elseif type == "Weapon" and (subType == "Crossbows" or subType == "Guns") then
		equipLoc = "INVTYPE_RANGED";
	end
	
	if not FHDKP_ItemValue[quality] or not FHDKP_SlotValue[equipLoc] then
		return nil;
	end

	local levelDiff = itemLevel - minLevel;
	if levelDiff <= 0 then
		levelDiff = 1;
	end

	return levelDiff * FHDKP_ItemValue[quality] * FHDKP_SlotValue[equipLoc];
end

------------------------------------------------------
-- Runtime loading
------------------------------------------------------

FHDKP_OnLoad();
